<?php
/**
 * webtrees: online genealogy
 * Copyright (C) 2015 webtrees development team
 * Copyright (C) 2015 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
namespace Andre\WebtreesAddOn\Arbre\Schema;

use Fisharebest\Webtrees\Database;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Schema\MigrationInterface;
use Fisharebest\Webtrees\Tree;
use Fisharebest\Webtrees\Log;



/**
 * Upgrade the database schema from version 1 to version 2.
 */
class Migration0 implements MigrationInterface {

	/** {@inheritDoc} */
	public function upgrade() {		
	//Default values: one data / sex to -> user's Preference limited to 255 chars
	//Initialise colors for fan chart: ARBRE_FAN_COLORS
	
	$dir = 'arbre_cache';
	$file_cache = 'arbre.txt';	
	$sql = "SELECT  setting_value from `##module_setting` " .
		"WHERE module_name = 'arbre' " .
		"AND setting_name = 'ARBRE_CACHE_DIR'; ";	
	Log::addConfigurationLog('arbre: update cache values rq1' .$sql);	
	$rq = Database::prepare($sql)->execute()->fetchAll();  
	Log::addConfigurationLog('arbre: update cache values rq1');
		if ( count($rq) > 0 ){
               //update 
			$sql = "UPDATE `##module_setting` SET setting_value='" . $dir ."'  " .
					"WHERE setting_name='ARBRE_CACHE_DIR' " .
					"AND module_name = 'arbre';";   
			Database::prepare($sql)->execute();			
			Log::addConfigurationLog('arbre: update cache values' . $dir);
		} else {
			//INSERT
		$sql = "INSERT INTO `##module_setting` (module_name, setting_name, setting_value) " .
				"VALUES  ('arbre','ARBRE_CACHE_DIR' , '" . $dir ."');";	
		Database::prepare($sql)->execute();
			Log::addConfigurationLog('arbre: insert cache values' . $dir);			
		}
		
	$sql = "SELECT  setting_value from `##module_setting` " .
		"WHERE module_name = 'arbre' " .
		"AND setting_name = 'ARBRE_CACHE_FILE'; ";	
	Log::addConfigurationLog('arbre: update cache values rq1' .$sql);	
	$rq = Database::prepare($sql)->execute()->fetchAll();  
	Log::addConfigurationLog('arbre: update cache values rq1');
		if ( count($rq) > 0 ){
               //update 
			$sql = "UPDATE `##module_setting` SET setting_value='" . $file_cache ."'  " .
					"WHERE setting_name='ARBRE_CACHE_FILE' " .
					"AND module_name = 'arbre';";   
			Database::prepare($sql)->execute();			
			Log::addConfigurationLog('arbre: update cache values' . $file_cache);
		} else {
			//INSERT
		$sql = "INSERT INTO `##module_setting` (module_name, setting_name, setting_value) " .
				"VALUES  ('arbre','ARBRE_CACHE_FILE' , '" . $file_cache ."');";	
		Database::prepare($sql)->execute();
			Log::addConfigurationLog('arbre: insert cache values' . $file_cache);			
		}	
		// fin creation 
 
	}
}

?>