<?php
/**
 * webtrees: online genealogy
 * Copyright (C) 2015 webtrees development team
 * Copyright (C) 2015 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *---------------------------------------------------------------------
 *   V 1.0.1 for "arbre" V-1-7-2 for Webtrees 1.7.2
*   André DUMAS August 2015
*   http://www.adumas.1s.fr/wt
*
*	V-1-0 for Arbre V-1-7-9-1  WT 1.7.9  15 JAN 2017
*			print circle fan trees 180/270/360°  5 gen <- main tab
 */
namespace Andre\WebtreesAddOn\Arbre\Template;

use Fisharebest\Webtrees\File;
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\I18N;
use Andre\WebtreesAddOn\Arbre\ArbreClass;
use Andre\WebtreesAddOn\Arbre\ArbreModule;

use Andre\WebtreesAddOn\Arbre\Template\PdfPageController;
use Andre\WebtreesAddOn\Arbre\Template\myPDFTools;
use TCPDF;

class PdfImgTemplate_1 extends ArbreModule {
	
	const PdfTemplate_CUSTOM_VERSION  = '2-0';
	const PdfTemplate_CUSTOM_VERSION_DATE  = '2017-09-15';
	const PdfTemplate_CUSTOM_VERSION_AUTHOR  = 'André DUMAS FRANCE';
	
	
	public function pageBody($format, $type = 'fan') {
		global $WT_TREE;
		
				$temp = WT_DATA_DIR . ArbreModule::getSetting('ARBRE_CACHE_DIR');			
				$f = DIRECTORY_SEPARATOR . $type . '_' . 'arbre.png' ;
				$titre = 'Fan chart';			
				$cache = $temp . $f;
			
				$imgdata = file_get_contents($cache);
			
			$header = '<div style="width:100%;">'.$WT_TREE->getTitle(). '     :     ' . $titre .'</div>';	
			$footer = '<div style="width:100%;">'
						. 'Module "arbre" for Webtrees @AD 2015-2016-2017'.'</div>';
		// ---------------------------------------------------------
		$PDF_PAGE_FORMAT = $format;
		$PDF_UNIT = 'mm';
		$PDF_PAGE_ORIENTATION = 'L'; //L pour paysage


		$pdf = new PdfPageController($PDF_PAGE_FORMAT, PDF_PAGE_ORIENTATION);
		$tool = new myPDFTools();

		// set font
		$pdf->SetFont('dejavu sans', 'BI', 7);
		//-------------------------------------------------------------

		// set auto page breaks
		$pdf->SetAutoPageBreak(FALSE, PDF_MARGIN_BOTTOM);

		// set image scale factor
		$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

		//---------------------------------------------------------------
		// add a page
		$pdf->AddPage();  

		// set JPEG quality
		$pdf->setJPEGQuality(75);
		$pdf->header = $header;
		$pdf->Header();
				$pdf->Image('@'.$imgdata, 30, 60, 130, 130, 'PNG', 'http://www.adumas.1s.fr/wt', 'M', true, 150, 'C', false, false, 1, false, false, false);
			
		$pdf->footer = $footer;
		$pdf->Footer();		
		
			$pdf->Output('Fan-chart' . '.pdf', 'I');
				
	}
	
	

}