<?php
/**
 * webtrees: online genealogy
 * Copyright (C) 2015 webtrees development team
 * Copyright (C) 2015 JustCarmen
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *---------------------------------------------------------------------
 *   V 1.0.1 for "arbre" V-1-7-2 for Webtrees 1.7.2
*   André DUMAS August 2015
*   http://www.adumas.1s.fr/wt
*
*	V-1-1 for Arbre V-1-7-6-1  WT 1.7.6  25 JUN 2016
*	V-1-2 for Arbre V-1-7-8-1  WT 1.7.8  20 NOV 2016
*	V-1-3 for Arbre V-1-7-9-1  WT 1.7.9  15 JAN 2017
*			Lines and arcs
 */
namespace Andre\WebtreesAddOn\Arbre\Template;

use Fisharebest\Webtrees\File;
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Auth;
use Fisharebest\Webtrees\Individual;
use Andre\WebtreesAddOn\Arbre\ArbreClass;
use Andre\WebtreesAddOn\Arbre\ArbreModule;

use Andre\WebtreesAddOn\Arbre\Template\PdfPageController;
use Andre\WebtreesAddOn\Arbre\Template\myPDFTools;

use TCPDF;
use TCPDF_STATIC;

class PdfNewTreeTemplate_1 extends ArbreModule {
	
	const PdfTemplate_CUSTOM_VERSION  = '2-0';
	const PdfTemplate_CUSTOM_VERSION_DATE  = '2017-09-15';
	const PdfTemplate_CUSTOM_VERSION_AUTHOR  = 'André DUMAS FRANCE';
	
	
	var $tree_colors;
		
	public function pageBody($format, $type = 'fan', $colorType = 2) {
		global $WT_TREE;
		
			$this->initColors($colorType);
		
		// on lit le tableau de valeurs
			$temp = WT_DATA_DIR . ArbreModule::getSetting('ARBRE_CACHE_DIR');			
			$f = DIRECTORY_SEPARATOR . 'arbre.txt' ;							
			$cache = $temp . $f;				
			//Commence à 1 TODO
			$data = unserialize(file_get_contents($cache));
				
				$person = Individual::getInstance($data[1][0]["id"], $WT_TREE);		
				$titre = I18N::translate('Fan chart ') . '  ' . $person->getAllNames()[$person->getPrimaryName()]['fullNN'] ;
			
			$header = '<div style="width:100%;height:5%;">'.$WT_TREE->getTitle(). '     :     ' . $titre .'</div>';	
			$footer = '<div style="width:100%;">'
						. 'Module "arbre" for Webtrees @AD 2015-2016-2017'.'</div>';
// ---------------------------------------------------------
if (!is_array($format)){
$PDF_PAGE_FORMAT = $format;
} else {
	
	$PDF_PAGE_FORMAT = 'A4';
}

$PDF_UNIT = 'pt';
$PDF_PAGE_ORIENTATION = 'L'; //L pour paysage

/////////////
$pdf = new PdfPageController($PDF_PAGE_FORMAT, $PDF_PAGE_ORIENTATION);
$tool = new myPDFTools();

// set font
$size = 4;
$pdf->SetFont('dejavu sans', 'BI', $size);
//-------------------------------------------------------------

// set auto page breaks
$pdf->SetAutoPageBreak(FALSE, PDF_MARGIN_BOTTOM);

//---------------------------------------------------------------
// add a page
$pdf->AddPage();  

// set JPEG quality
//$pdf->setJPEGQuality(75);

$twidth  = $pdf->getPageWidth();
$theight = $pdf->getPageHeight();
/////////////
//Cercle:
//Centre $xc, $yc
$xc = $twidth / 2 - $twidth*0.007;
$yc = $theight - $theight*0.05; //bottom of the page - 10
///////////////
$lightblue = array(173, 216, 230);
$lightpink = array(254, 182, 193);

/* background image
	$imgW = $twidth;
	$imgH = $theight;
	$imgPath = WT_MODULES_DIR . $this->getName() . '\images\bkgd.png';
	$imgType = 'PNG';
	
	//	$pdf->Image($imgPath, 0, 0, $imgW, $imgH, $imgType, '', 'C', false, 300, '', false, false, 1, false, false, false);
*/

$titre .=  '  ' . $tool->getMyLifeSpan($person);
$pdf->header = $header;
$pdf->Header();

// X Y axis
$color = array(255, 12, 55);

	//------------Boucle
	$window = 180;
	$gen = count($data);
	$start = 0;
	$r = 0.9 * $twidth /2  / $gen;
	$maxCharLn = 15; // nbr max chars/line
	$size = $r / $maxCharLn; // 15 chars max
	$pdf->SetFont('dejavu sans', 'BI', $size);

	$pdf->SetLineWidth(0.5);

	for ($j = 0; $j < $gen; $j++){
		$ids = pow(2, $j);
		$inc = $window / $ids;
		
		
		if ($j > 4){
			$size = 0.8 * $size;
	$pdf->SetFont('dejavu sans', 'BI', $size);
		}
		
		if ($j == 0){
			$person = Individual::getInstance($data[1][0]["id"], $WT_TREE);
			$lifeInt = $tool->getMyLifeSpan($person);
			$media = $person->findHighlightedMedia();
			$link = WT_BASE_URL . 'individual.php?pid=' . $data[1][0]["id"] . '&ged=' . $WT_TREE->getName();
			
			if (($media != null) && ($media->fileExists('thumb')) ) {
				$imgType = strtoupper($media->extension());
				if ($imgType == 'PNG' || $imgType == 'JPG' || $imgType == 'JPEG'){
					$imgPath = $media->getServerFilename('thumb');
				} 
			} 
			
					switch ($person->getSex()) {
							case 'M':
								$pdf->SetTextColorArray($this->tree_colors['M']['txt']);
								$pdf->SetFillColorArray($this->tree_colors['M']['bgd']);
								if (($media == null) || !($media->fileExists('thumb')) ){
									$imgPath = '';
									$imgType = 'PNG';
									$imgData = (img_Class::getImage('male'));
								}
							break;	
							case 'F':
								$pdf->SetTextColorArray($this->tree_colors['F']['txt']);
								$pdf->SetFillColorArray($this->tree_colors['F']['bgd']);
								if (($media == null) || !($media->fileExists('thumb'))  ){
									$imgPath = '';
									$imgType = 'PNG';
									$imgData = (img_Class::getImage('female'));
								}
							break;	
							default:
								$pdf->SetTextColorArray($this->tree_colors['U']['txt']);
								$imgPath = '';
								$imgData = (img_Class::getImage('unknown'));
							break;	
					}
				
			//Title	
			
			$imgW = $theight / 8;
			if (($media != null) && ($media->fileExists('thumb')) ) {
			$pdf->Image($imgPath, $twidth*0.08, $theight*0.08, $imgW, '', $imgType, '', 'T', false, 300, '', false, false, 1, false, false, false);
			} else {
				$html = '<img  style="width:500pt;"
					src="'.$imgData . '" />';

				$pdf->writeHTMLCell(	$w= $imgW,
											$h = $imgW,
											$x= $twidth*0.08,
											$y = $theight*0.08,
											$html,
											$border = 0,
											$ln = 0,
											$fill = false,
											$reseth = true,
											$align ='',
											$autopadding = true 
									) ;	
			}
			$tsize = $theight / 45;
			$pdf->SetFont('dejavu sans', 'BI', $tsize);
			$name = $person->getAllNames()[$person->getPrimaryName()]['fullNN'] ;
			$xn = $xc - strlen($name)* $tsize / 3;
				$text = $name . '  ' . $lifeInt;
				$pdf->SetX($twidth*0.25);
				$pdf->SetY($theight*0.1);
				$pdf->setCellPadding(15);
				$pdf->setCellMargins($left= $twidth*0.25);						
					$pdf->Cell($twidth*0.65, 0, $text, 1, 1, 'C', 1,  $link, 4);
			$pdf->SetFont('dejavu sans', 'BI', $size);
			$pdf->setCellMargins($left= 0);
			$pdf->setCellPadding(0);
			
			//First gen
			$text = $tool->getMyShortName($person, $maxCharLn);
			$stop = 180;	
				$pdf->PieSector($xc, $yc, $r, $start, $stop, 'FD', false, 0, 2);
				$pdf->Line($xc - $r, $yc, $xc + $r, $yc);
			
			$pdf->SetFont('dejavu sans', 'B', 2*$size);	
				$ln = 	$pdf->GetStringWidth 	( 	$text) ;	
			$lfi = 	$pdf->GetStringWidth 	( 	$lifeInt) ;											
			
			
			//centrage
			$delta = ($r*1.8 - $ln)/2;
			$deltai = ($r*1.8 - $lfi)/2;
				$pdf->Text($xc -$r*0.9 + $delta, $yc - 0.66 * $r, $text);
				$pdf->Text($xc -$r*0.9 +  $deltai, $yc - 0.33 * $r, $lifeInt);
				$inc = 180; $id = 0;
				//$this->arcWrite($pdf, $text, $xc, $yc, $r*1.3, $maxCharLn, $inc, $id);
				$pdf->SetFont('dejavu sans', 'BI', $size);
		} 
		else {
		$r1 = $j * $r;
			for ($i = 0; $i < $ids; $i++){	
			
				$person = Individual::getInstance($data[$j + 1][$i]["id"], $WT_TREE);
				if ($person){
					$lifeInt = $tool->getMyLifeSpan($person);
					switch ($person->getSex()) {
					case 'M':
						$pdf->SetTextColor(0, 0, 255); //blue
					break;	
					case 'F':
						$pdf->SetTextColor(255, 0, 0); //red
					break;	
					default:
						$pdf->SetTextColor(0, 0, 0);//black
					break;	
				}
					$text = $tool->getMyShortName($person, $maxCharLn);
				} else {
					$text = '? ?';
					$lifeInt = '( ? - ? )';
					$pdf->SetTextColor(0, 0, 0);
				}
										
				$ang_i = ($i * $inc);
				$xp1 = $xc - $r1*cos( ($inc/2 + $ang_i) * 3.1415/180 );
				$yp1 = $yc - $r1*sin( ($inc/2 + $ang_i) * 3.1415/180 );
				
				$r2 = $r1 + $r;
				$xp2 = $xc -  $r2*cos( ($inc/2 + $ang_i) * 3.1415/180 );
				$yp2 = $yc - $r2*sin( ($inc/2 + $ang_i) * 3.1415/180 );
				$pdf->Line($xp1, $yp1, $xp2, $yp2);
				$alpha = 0;
				
				$rot = $inc/2 + $ang_i;
				//
				// behind gen 7
			if ($inc < 10){  // 3 - 180/64
				$alpha = 1;
				$text .= ' ' . $lifeInt;							
			}
			
			$ln = 	$pdf->GetStringWidth 	( 	$text) ;	
			if ($ln > $r ){
						$size = $pdf->GetFontSize()*$r/$ln;
						$pdf->SetFontSize($size);
			}										
													
			
			
			//centrage
			$delta = ($r - $ln)/2;
				
				//
				
				if ($rot < 90){	
					$xp2 = $xc -  ($r2 - $alpha*$delta)*cos( ($inc/2 + $ang_i) * 3.1415/180 );
					$yp2 = $yc - ($r2 - $alpha*$delta)*sin( ($inc/2 + $ang_i) * 3.1415/180 );	
					$xt = $xp2 + 1.6*$size*sin($rot*3.1415/180) ;
					$yt = $yp2 - 1.6*$size*cos($rot*3.1415/180) ; 
					
					$xli = $xp2 - 0.4*$size*sin($rot*3.1415/180) ;
					$yli = $yp2 + 0.4*$size*cos($rot*3.1415/180); 
					
					$rot =  -$rot;
				// Start Transformation
					$pdf->StartTransform();		
					$pdf->Rotate($rot, $xt, $yt);
					$pdf->Text($xt, $yt , $this->alignText($text, $r, $maxCharLn));
					$pdf->StopTransform();
					if ($alpha == 0){
						$pdf->StartTransform();
						$pdf->Rotate( $rot, $xli, $yli);
						$pdf->Text($xli, $yli , $this->alignText($lifeInt, $r, $maxCharLn));
						// Stop Transformation
						$pdf->StopTransform();
					}
				} else {
					$xp1 = $xc - ($r1 + $alpha*$delta)*cos( ($inc/2 + $ang_i) * 3.1415/180 );
					$yp1 = $yc - ($r1 + $alpha*$delta)*sin( ($inc/2 + $ang_i) * 3.1415/180 );
					$xt = $xp1 - 1.6*$size*sin($rot*3.1415/180) ;
					$yt = $yp1 + 1.6*$size*cos($rot*3.1415/180) ;
					
					
					$xli = $xp1 + 0.4*$size*sin($rot*3.1415/180) ;
					$yli = $yp1 - 0.4*$size*cos($rot*3.1415/180) ; 
					
					$rot = 180 - $rot;
					// Start Transformation
					$pdf->StartTransform();		
					$pdf->Rotate($rot, $xt, $yt);
					$pdf->Text($xt, $yt , $this->alignText($text, $r, $maxCharLn) );				
					$pdf->StopTransform();
					if ($alpha == 0){
						$pdf->StartTransform();
						$pdf->Rotate( $rot, $xli, $yli);
						$pdf->Text($xli, $yli , $this->alignText($lifeInt, $r, $maxCharLn));					
						// Stop Transformation
						$pdf->StopTransform();
					}
					
					}
				
				if ($j < $gen -1){
					$start = $inc / 2  + $ang_i - $inc /4;
					$stop = $start + $inc /2;
					$pdf->Circle($xc, $yc , $r2, $start, $stop, 'D', array(), array(), 2);
				}
			}
		
			
		}
	}

	//-------------
	$pdf->footer = $footer;
	$pdf->Footer();
				
				$pdf->Output('Fan-chart' . '.pdf', 'I');
									 
	}
	
	
	
	
	
	/* len($text) < $max see MyShortName
	*  add spaces -> center text 
	*	param 	$max: max chars /line ->  fix size 
	*			$r   rayon
	*	return text with 15 chars centered
	*/
	private function alignText($text, $r, $max = 15){
			$n = (int)abs($max - strlen($text) / 2 );
			$t = str_repeat(' ', $n) . $text;
			return $t;
	}

		private function arcWrite(PdfPageController $pdf,$text, $cx, $cy, $r, $maxChars, $inc, $id){
		$text = utf8_decode($text);
		$angleM = $id * $inc + $inc/2;
		$nbrLettres = strlen($text);
		$l_arc = 3.1415*$r*$inc/180;
		
	//$size = $l_arc*0.95/$maxChars;
	//$pdf->SetFontSize($size);
		$size = $pdf->GetFontSize();
		$step = $inc*0.8/($nbrLettres);
		  if ($step > 10){
			  $step = 10;
		  }
	  
	  $step *= 1.0;
	  $phy = $id*$inc + ($inc - ($step * $nbrLettres)) / 2;
	  $r -= 2*$size;
  for ($i = 0; $i < $nbrLettres; $i++){
    $angle = $phy + $i * $step;
    $angleRAD = $angle * 3.1415/180;
	
    $x = $cx - cos($angleRAD)*$r;
    $y = $cy - sin($angleRAD)*$r;
		$pdf->startTransform();
			$pdf->Rotate(90 - $angle, $x, $y);
			$pdf->Text($x, $y, $text[$i]);
		$pdf->stopTransform();
	}

	return true;
		
	}

	/*
	*	set text color, return bckgd color /sex
	*/
	private function setColors($pdf, $person){
		//colors													
						switch ($sex = $person->getSex()) {
							case 'M':
								$pdf->SetTextColorArray($this->tree_colors['M']['txt']);
								$color = $this->tree_colors['M']['bgd'];
								
							break;	
							case 'F':
								$pdf->SetTextColorArray($this->tree_colors['F']['txt']);
								$color = $this->tree_colors['F']['bgd'];
							break;	
							default:
								$pdf->SetTextColorArray($this->tree_colors['U']['txt']);
								$color = $this->tree_colors['U']['bgd'];
							break;	
						}
	return color;					
	}
	
	/*
	*	Init colors for sectors and text
	*
	*/
	private function initColors($colorSet){	
		$sexs = array('M', 'F', 'U');
		$this->tree_colors = array();
		foreach ($sexs as $sex){
			switch ($colorSet){
				case '1'://default		
					
					$this->tree_colors[$sex] = unserialize($this->getSetting('TREE_COLORS_' . $sex));
				break;
				case '2':
				if (Auth::user()->getPreference('TREE_COLORS_' . $sex ) ) {
					$this->tree_colors[$sex] = unserialize(Auth::user()->getPreference('TREE_COLORS_' . $sex ));
				} else {
					$this->tree_colors[$sex] = unserialize($this->getSetting('TREE_COLORS_' . $sex));
				}
				break;
					case '3':
						//classic				
					 $TEXT_COLOR_LIGHT_M = array(0, 0, 255);
					 $FILL_COLOR_LIGHT_M = array(173, 216, 230); //lightblue
					 $TEXT_COLOR_LIGHT_F = array(0, 0, 255);
					 $FILL_COLOR_LIGHT_F = array(254, 182, 193); //lightpink
					
					 $TEXT_COLOR_LIGHT_U = array(0, 0, 0);
					 $FILL_COLOR_LIGHT_U = array(180, 180, 180);
					 
					$this->tree_colors['M'] = array( 'bgd' => $FILL_COLOR_LIGHT_M, 'txt' => $TEXT_COLOR_LIGHT_M); 
					$this->tree_colors['F'] = array( 'bgd' => $FILL_COLOR_LIGHT_F, 'txt' => $TEXT_COLOR_LIGHT_F); 
					$this->tree_colors['U'] = array( 'bgd' => $FILL_COLOR_LIGHT_U, 'txt' => $TEXT_COLOR_LIGHT_U); 
		
				break;
				case '4':
					//black/white				
					 $TEXT_COLOR_LIGHT_M = array(0, 0, 255);
					 $FILL_COLOR_LIGHT_M = array(255, 255, 255); //white
					 
					 $TEXT_COLOR_LIGHT_F = array(255, 0, 0);
					 $FILL_COLOR_LIGHT_F = array(255, 255, 255); //lightpink
					
					 $TEXT_COLOR_LIGHT_U = array(0, 0, 0);
					 $FILL_COLOR_LIGHT_U = array(255, 255, 255);
					 
					$this->tree_colors['M'] = array( 'bgd' => $FILL_COLOR_LIGHT_M, 'txt' => $TEXT_COLOR_LIGHT_M); 
					$this->tree_colors['F'] = array( 'bgd' => $FILL_COLOR_LIGHT_F, 'txt' => $TEXT_COLOR_LIGHT_F); 
					$this->tree_colors['U'] = array( 'bgd' => $FILL_COLOR_LIGHT_U, 'txt' => $TEXT_COLOR_LIGHT_U); 
		
				break;
				
			}	
		}
		if ($colorSet == 3){
			//classic				
					 $TEXT_COLOR_LIGHT_M = array(0, 0, 255);
					 $FILL_COLOR_LIGHT_M = array(173, 216, 230); //lightblue
					 $TEXT_COLOR_LIGHT_F = array(0, 0, 255);
					 $FILL_COLOR_LIGHT_F = array(254, 182, 193); //lightpink
					
					 $TEXT_COLOR_LIGHT_U = array(0, 0, 0);
					 $FILL_COLOR_LIGHT_U = array(180, 180, 180);
					 
					$this->tree_colors['M'] = array( 'bgd' => $FILL_COLOR_LIGHT_M, 'txt' => $TEXT_COLOR_LIGHT_M); 
					$this->tree_colors['F'] = array( 'bgd' => $FILL_COLOR_LIGHT_F, 'txt' => $TEXT_COLOR_LIGHT_F); 
					$this->tree_colors['U'] = array( 'bgd' => $FILL_COLOR_LIGHT_U, 'txt' => $TEXT_COLOR_LIGHT_U); 
		}
		//set background
		if (($pref = Auth::user()->getPreference('TREE_BGD' )) == null){
			$this->bgd = $this->getSetting('TREE_BGD');
		} else {
			$this->bgd = $pref;
		}	
		
	return true;	
	}

	
}