<?php
namespace Andre\WebtreesAddOn\Arbre\Template;

use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Individual;

class myPDFTools {

	
	public function getMyShortName(Individual $person, $lenMax){
		global $WT_TREE;
		if ($person == null){return '? ?';}
		if ($person->canShowName()) {
			$tmp        = $person->getAllNames();
			$givn       = $tmp[$person->getPrimaryName()]['givn'];
			$surn       = $tmp[$person->getPrimaryName()]['surname'];
			$new_givn   = explode(' ', $givn);
		
			if (strlen($givn . ' ' . $surn) <= $lenMax ){
				return $givn . ' ' . $surn;
			}
		
			if (count($new_givn) > 1){ 
				$givn = $new_givn[0] . '..';
			}
			$shortname = $givn . '  ' . $surn;
			
			if (strlen($shortname) > $lenMax) {
				$shortname = substr($givn, 0 , 1) . '. ' . $surn;
			}
			//Encore trop long
			if (strlen($shortname) > $lenMax) {
				$shortname = substr($shortname, 0 , $lenMax -2) . '..';
			}
			
			return $shortname;
		} else {
			return I18N::translate('Private');
		}
	}
	
	/*
	*  with only the first char of the first name  $gen > 6
	*/
	public function getMyShortName2(Individual $person, $lenMax){
		global $WT_TREE;
		if ($person == null){return '? ?';}
		if ($person->canShowName()) {
			$tmp        = $person->getAllNames();
			$givn       = $tmp[$person->getPrimaryName()]['givn'];
			$surn       = $tmp[$person->getPrimaryName()]['surname'];
			$new_givn   = explode(' ', $givn);
		
			if (count($new_givn) > 1){ 
				$givn = $new_givn[0] . '..';
			}
			
				$shortname = substr($givn, 0 , 1) . '. ' . $surn;
			
			//Encore trop long
			if (strlen($shortname) + 15 > $lenMax) {
				$shortname = substr($shortname, 0 , $lenMax -8) . '..';
			}
			
			return $shortname;
		} else {
			return I18N::translate('Private');
		}
	}
	
	
	/*
	*	return tab[0] tab[1...] givnsurname
	*/
	public function getMyTabNames(Individual $person, $lenMax = 40){
		global $WT_TREE;
		if ($person == null){return array('?', '?');}
		if ($person->canShowName()) {
			$tmp        = $person->getAllNames();
			$givn       = $tmp[$person->getPrimaryName()]['givn'];
			$surn       = $tmp[$person->getPrimaryName()]['surname'];
			$new_givn   = explode(' ', $givn);
			
			$tab = array($surn);
			return array_merge($tab, $new_givn);
		}
	
	}
	
	
		/*
	*	my LifSpan 
	*/
	public function getMyLifeSpan($person){
		$db = $person->getBirthDate()->minimumDate()->format('%Y');
		if (!$db){$db = '? ';}
		$dd = $person->getDeathDate()->minimumDate()->format('%Y');
		if (!$dd){$dd = ' ?';}
		
	return '(' . $db . ' - ' .$dd . ')';	
	}




}

?>