<?php
namespace Andre\WebtreesAddOn\Arbre;

use Fisharebest\Webtrees\Tree;
use Fisharebest\Webtrees\Family;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Auth;
use Fisharebest\Webtrees\Theme;
use Fisharebest\Webtrees\Individual;
use Fisharebest\Webtrees\GedcomRecord;


class familyTools {

	static $typeTree = 'main';	

	/*
	*  	============= Cousins  ======================
	*/
	
		protected static  function getCousins($pid){
		
		$h_uncles = self::getUncles($pid);		
		//////////////   COUSINS    /////////////
		$cousins = array();
		/*  cousins  */
				
			foreach ($h_uncles as $fam =>$uncles){
				foreach ($uncles as $uncle){
					if ($uncle->getSpouseFamilies() ) {
						foreach ($uncle->getSpouseFamilies() as $ufam){
									$cousinstmp = array($ufam->getXref() => $ufam->getChildren() ); 
									$cousins = array_merge($cousins, $cousinstmp );									
						}
					}
				}	
			}

	return $cousins;
	}

	protected static  function getUncles($pid){
		global $WT_TREE;
		
		
		//-------------------
		/*
*						gppid	gmpid	gpmid	gmmig									-> enfants = gd oncles
*							pid				mid       			-> enfants = oncles
*								id								cousins g id
*/
		
		$person   = Individual::getInstance($pid, $WT_TREE);
		
		/*			methodes utilisées
		*   getChildFamilies  getSpouseFamilies
		*	$family ->getChildren()->getXref()
		*    $person->getChildStepFamilies()
		*	getFullName() getPrimaryName()
		*/
		
		/* Parent's family */
		$parentsIds = array();
		$gd_parentsIds = array();
		$unclesIds = array();
		$cousins = array();
		$uncles = array();
		$siblings = array();
		$siblings_pere = array();
		$siblings_mere = array();
		$h_gd_parentFamily = null;
		$w_gd_parentFamily = null;
		
		/* parents  */
		if ($person->getPrimaryChildFamily()) {
			$parentFamily = $person->getPrimaryChildFamily();
			$parentsIds[] = $parentFamily->getHusband()->getXref();
			$parentsIds[] = $parentFamily->getWife()->getXref();
		
		/* frères et soeurs de id */
		
		
		$siblings = $parentFamily->getChildren(); 
		
		/* gd parents  de id */
		/*  husband's gd parents   */
			
			$h_gd_parentFamily = $parentFamily->getHusband()->getPrimaryChildFamily();//gd parents paternels
			$w_gd_parentFamily = $parentFamily->getWife()->getPrimaryChildFamily();   // gd parents maternels  
	}	
	if ($w_gd_parentFamily){
			$gd_parentsIds[] = $w_gd_parentFamily->getHusband()->getXref();
			$gd_parentsIds[] = $w_gd_parentFamily->getWife()->getXref();
			// frères et soeurs des  père  & mère -> oncle et tantes de xref
			$siblings_mere = $w_gd_parentFamily->getChildren();
			}
			if ($h_gd_parentFamily){
			$gd_parentsIds[] = $h_gd_parentFamily->getHusband()->getXref();
			$gd_parentsIds[] = $h_gd_parentFamily->getWife()->getXref();
			// frères et soeurs des  père  & mère -> oncle et tantes de xref
			$siblings_pere = $h_gd_parentFamily->getChildren();
			}
		// frères et soeurs des  père  & mère -> oncle et tantes de xref
		//$siblings_pere = $h_gd_parentFamily->getChildren();
		//$siblings_mere = $w_gd_parentFamily->getChildren();
		
			///////////////    UNCLES  /////////////////////////
		$h_uncles = array();
	
		$h_tmp = array();
		$w_tmp = array();
	if ($siblings_pere){	
		foreach ($siblings_pere as $sib){
			if (!in_array($sib->getXref(), $parentsIds)  ){
				$h_tmp[] = $sib;
			}
		}
		$h_uncles = array_merge($h_uncles,array($h_gd_parentFamily->getXref() => $h_tmp)) ;
	}
	if ($siblings_mere){
		foreach ($siblings_mere as $sib){
			if (!in_array($sib->getXref(), $parentsIds)  ){
				$w_tmp[] = $sib ;
			}
		}
		$h_uncles = array_merge($h_uncles,array($w_gd_parentFamily->getXref() => $w_tmp)) ;
	}	
		
		//demi frère soeurs du père
		//remariage gd père patenel
	if ($h_gd_parentFamily){	
		$h_gdf_Families = $h_gd_parentFamily->getHusband()->getSpouseFamilies();
		foreach ($h_gdf_Families as $sfam){
			if ( $sfam->getXref() != $h_gd_parentFamily->getXref() ){
				$h_uncles = array_merge($h_uncles, array($sfam->getXref()=> $sfam->getChildren() ));
			}
			
		}
	
	
		//remariage gd mère paternelle
	
		$h_gdm_Families = $h_gd_parentFamily->getWife()->getSpouseFamilies();
		foreach ($h_gdm_Families as $sfam){
			if ( $sfam->getXref() != $h_gd_parentFamily->getXref() ){
				$h_uncles = array_merge($h_uncles, array($sfam->getXref()=> $sfam->getChildren() ));
			}
			
		}
	}
	
		//demi frère soeurs de la mère
		//remariage gd père matenel
	if ($w_gd_parentFamily){
		$w_gdf_Families = $w_gd_parentFamily->getHusband()->getSpouseFamilies();
		foreach ($w_gdf_Families as $sfam){
			if ( $sfam->getXref() != $w_gd_parentFamily->getXref() ){
				$h_uncles = array_merge($h_uncles, array($sfam->getXref()=> $sfam->getChildren() ));
			}
			
		}
		//remariage gd mère maternelle
		$w_gdm_Families = $w_gd_parentFamily->getWife()->getSpouseFamilies();
		foreach ($w_gdm_Families as $sfam){
			if ( $sfam->getXref() != $w_gd_parentFamily->getXref() ){
	
				$h_uncles = array_merge($h_uncles, array($sfam->getXref()=> $sfam->getChildren() ));
			}
			
		}
	}	
	
	return $h_uncles;
	}

	/*
	*   return gdParents[] with pids
	*/
	protected static  function getGrandParents($xref){
		global $controller, $WT_TREE;
		global $TEXT_DIRECTION;

		$person   = Individual::getInstance($xref, $WT_TREE);
		
		/* Parent's family */
		$parentsIds = array();
		$gd_parentsIds = array();
		
		$h_gd_parentFamily = null;
		$w_gd_parentFamily = null;
		
		/* parents  */
		if ($person->getPrimaryChildFamily()) {
				$parentFamily = $person->getPrimaryChildFamily();
				
			/* gd parents  de id */
			/*  husband's gd parents   */
				
				$h_gd_parentFamily = $parentFamily->getHusband()->getPrimaryChildFamily();//gd parents paternels
				$w_gd_parentFamily = $parentFamily->getWife()->getPrimaryChildFamily();   // gd parents maternels  
		}	
		if ($w_gd_parentFamily){
				$gd_parentsIds[] = $w_gd_parentFamily->getHusband()->getXref();
				$gd_parentsIds[] = $w_gd_parentFamily->getWife()->getXref();
				}
		if ($h_gd_parentFamily){
				$gd_parentsIds[] = $h_gd_parentFamily->getHusband()->getXref();
				$gd_parentsIds[] = $h_gd_parentFamily->getWife()->getXref();
		}
	return $gd_parentsIds;
	}
	
	/*
	*	Frères et soeurs du personnage actif
	*
	*/
	public static  function getSiblings($xref){
		global  $WT_TREE;
		
		$person   = Individual::getInstance($xref, $WT_TREE);
		
		/* Parent's family */
		$parentsIds = array();
		$siblings = array();
				
		/* parents  */
	if ($person->getPrimaryChildFamily()) {
			$parentFamily = $person->getPrimaryChildFamily();
			$parentsIds[] = $parentFamily->getHusband()->getXref();
			$parentsIds[] = $parentFamily->getWife()->getXref();
		
		/* frères et soeurs de id */
		
		$siblings = array($parentFamily->getXref()=> $parentFamily->getChildren()); 
		
		/* demi frère et soeurs: remariage des parents */		
		if ($parentFamily->getHusband()->getSpouseFamilies()){
			foreach ($parentFamily->getHusband()->getSpouseFamilies() as $fam){
				if ($fam && ($fam->getXref() != $parentFamily->getXref() ) ){
				//$siblings = array_merge($siblings, array($fam->getXref(), $fam->getChildren()) );
				$siblings = array_merge($siblings, array($fam->getXref() => $fam->getChildren())) ;
				}
			}
		}
		
		if ($parentFamily->getWife()->getSpouseFamilies() ){
			foreach ($parentFamily->getWife()->getSpouseFamilies() as $fam){
				if ($fam && ($fam->getXref() != $parentFamily->getXref() ) ){
				//$siblings = array_merge($siblings, array($fam->getXref(), $fam->getChildren()) );
				$siblings = array_merge($siblings, array($fam->getXref()=> $fam->getChildren()) );
				}
			}
		}
	}	
	return $siblings;		
	}
	
	
	/*
	*	nephews and nieces
	*/
	protected static  function getNephews($siblings){
		$nephews = array();
		foreach ($siblings as $fam => $sibs){
			foreach ($sibs as $sibling){
				foreach ($sibling->getSpouseFamilies() as $family){
					$nephews = array_merge( $nephews, array($family->getXref() => $family->getChildren()));
				}
			}
		}
		
	return $nephews;	
	}
	
	/*
	*
	*/
	protected static  function getGrandChildren($xref){
		global $WT_TREE;
		
		$person   = Individual::getInstance($xref, $WT_TREE);
		
		
		$GrandChildren = array();
		$children = null;
		
		$children = self::getAllChildren();
		
		if ($children){
			foreach ($children as $fam => $childs){
				foreach ($childs as $child){
					if ($child->getSpouseFamilies()){
						foreach ($child->getSpouseFamilies() as $gfam){
							$GrandChildren = array_merge($GrandChildren, array($gfam->getXref() => $gfam->getChildren()));
						}
					}	
				}
			}
		}
		
	
	return $GrandChildren;	
	}
	
	/*
	*	param $fam family
	*	return individuals[]
	*/
	protected static  function getAllChildren($xref){
			global $WT_TREE;
		
		$person   = Individual::getInstance($xref, $WT_TREE);
		
		$children = array();
		if ($person->getSpouseFamilies() ){
			foreach ($person->getSpouseFamilies() as $fam){
				$children = array_merge($children, array($fam->getXref() => $fam->getChildren() ) );
			}
		}
		return $children;
	}
	
	/*
	* 	get Family and step families
	*	return array($familyXref)
	*/
	private function getLargeFamily($pid){
		global $WT_TREE;
		$lfamily = array();
		$person   = Individual::getInstance($pid, $WT_TREE);
		/* Parents */
		$lfamily[] = $person->getPrimaryChildFamily()->getXref();

		/* step families */
		$fams = $person->getChildStepFamilies();
		foreach ($fams as $fam){
			$lfamily[] = $fam->getXref();
		}
	return $lfamily;	
	}
	
	/*
	*  Cognatique et agnatique arbre
	*	A chaque gen on ne s'intéresse qu'à la m_re/père
	*	fratrie -> frères/soeurs
	* 	arbre = array($gen => $fam)
	*   $select = 'A' / 'C'  Agnatic / Cognatic
	*/
	
	public static function getAgnaticPedigre($pid, $select = 'A'){
		global $WT_TREE;
		$arbre = array();
		$mothers = array();
		
		$person   = Individual::getInstance($pid, $WT_TREE);
		if ($person->getPrimaryChildFamily()){
			$pfamily = $person->getPrimaryChildFamily();
			$fratrie = $pfamily->getChildren();
		
			if ($select == 'A'){
				$p = $pfamily->getWife();
			} else {
				$p = $pfamily->getHusband();
			}
			$mothers = array($pfamily->getXref() => $fratrie);	
			
			while ($p){
			
				if ($p->getPrimaryChildFamily()){	
					$pfamily = $p->getPrimaryChildFamily();
						$fratrie = $pfamily->getChildren();	
						$mothers = array_merge($mothers, array($pfamily->getXref() => $fratrie));	
					/* next step */		
					
						if (($select == 'A') && $pfamily->getWife()){
							$p = $pfamily->getWife();
						} elseif (($select == 'C') && $pfamily->getHusband()){
							$p = $pfamily->getHusband();
						} 
						else {
							break;
						}
				} else {
					break;
				}	
			
			}
		} 
	return $mothers;	
	}
	

	
	private static function getLabel($person) {
		if ($person->canShow()){
	$html = '<p>
		<a class="arbreLien" href="'.$person->getHtmlUrl().'">'.
						$person->getFullName().'
					</a>'.' '.$person->getLifeSpan()
			.'</p>';
		} else {
			$html ='Détails privés';
		}	
	return $html;
	}
	
	
	/*	==============================================
	*	display $tab as a <select> list
	*	structure $tab[$i] = array($fam, $children)
	*	===============================================
	*/
	protected static  function listeUncles($h_uncles){
		global $controller, $WT_TREE;
		$html = '
			<select id="lUncles">
			<option value="">'.I18N::translate('List of uncles & taunts')  .'</option>';			 
			foreach ($h_uncles as $fam =>$uncles){
				
					$html .= '<option class="optionfam" disabled  value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE)) . '</option>';									
					foreach ($uncles as $uncle){			
						if ($uncle){
							$html .= '<option value="' .  $uncle->getXref() . '" onclick="javascript:location.href=\'' . $uncle->getHtmlUrl().'\'">' .  $uncle->getFullName() . ' - ' . $uncle->getLifeSpan()  . '</option>';
							}					
					}
			}			
		$html .= '		
			</select>';
	return $html;	
	}
	
		protected static  function listeCousins($tab){
		global $controller, $WT_TREE;
		$html = '
			<select id="lSiblings">
			<option value="">'.I18N::translate('List of cousins')  .'</option>';
			 
			foreach ($tab as $fam => $cousins){
				$html .= '<option disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</option>';				
					foreach ($cousins as $cousin ){
						$html .= '<option value="' .  $cousin->getXref() . '" onclick="javascript:location.href=\'' . $cousin->getHtmlUrl().'\'">' .  $cousin->getFullName() . ' - ' . $cousin->getLifeSpan()  . '</option>';
					}
			}
			
		$html .= '		
			</select>
		';
	return $html;	
	}
	
		protected static  function listeSiblings($tab){
		global $controller, $WT_TREE, $pid;
		$html = '
			<select id="lSiblings">
			<option value="">'.I18N::translate('List of siblings')  .'</option>';
			 
			foreach ($tab as $fam => $siblings){
				$html .= '<option disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</option>';				
					foreach ($siblings as $sibling ){
						if ($sibling->getXref() != $pid ){
							$html .= '<option value="' .  $sibling->getXref() . '" onclick="javascript:location.href=\'' . $sibling->getHtmlUrl().'\'">' .  $sibling->getFullName() . ' - ' . $sibling->getLifeSpan()  . '</option>';
						}
					}
			}
			
		$html .= '		
			</select>
		';
	return $html;	
	}

		protected static  function listeNephews($tab){
		global $controller, $WT_TREE, $pid;
		$html = '
			<select id="lSiblings">
			<option value="">'.I18N::translate('List of nephews & nieces ')  .'</option>';
			 
			foreach ($tab as $fam => $nephews){
				$html .= '<option disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</option>';				
					foreach ($nephews as $nephew ){
						if ($nephew->getXref() != $pid ){
							$html .= '<option value="' .  $nephew->getXref() . '" onclick="javascript:location.href=\'' . $nephew->getHtmlUrl().'\'">' .  $nephew->getFullName() . ' - ' . $nephew->getLifeSpan()  . '</option>';
						}
					}
			}
			
		$html .= '		
			</select>
		';
	return $html;	
	}

		protected static  function listeAllChildren($tab){
		global $controller, $WT_TREE, $pid;
		$html = '
			<select id="lSiblings">
			<option value="">'.I18N::translate('List of all children ')  .'</option>';
			 
			foreach ($tab as $fam => $children){
				$html .= '<option disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</option>';				
					foreach ($children as $child ){
						if ($child->getXref() != $pid ){
							$html .= '<option value="' .  $child->getXref() . '" onclick="javascript:location.href=\'' . $child->getHtmlUrl().'\'">' .  $child->getFullName() . ' - ' . $child->getLifeSpan()  . '</option>';
						}
					}
			}
			
		$html .= '		
			</select>
		';
	return $html;	
	}
	
	
		protected static  function listeGrandChildren($tab){
		global $controller, $WT_TREE, $pid;
		$html = '
			<select id="lSiblings">
			<option value="">'.I18N::translate('List of grand-children ')  .'</option>';
			 
			foreach ($tab as $fam => $gchildren){
				$html .= '<option disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</option>';				
					foreach ($gchildren as $gchild ){
						if ($gchild->getXref() != $pid ){
							$html .= '<option value="' .  $gchild->getXref() . '" onclick="javascript:location.href=\'' . $gchild->getHtmlUrl().'\'">' .  $gchild->getFullName() . ' - ' . $gchild->getLifeSpan()  . '</option>';
						}
					}
			}
			
		$html .= '		
			</select>
		';
	return $html;	
	}
	
	
		protected static  function listeGrandParents($tab){
		global $controller, $WT_TREE, $pid;
		$html = '
			<select id="lSiblings">
			<option value="">'.I18N::translate('List of grand-parents')  .'</option>';
			 
			foreach ($tab as $gdId){
				
				//$html .= '<option disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</option>';				
					$person = Individual::getInstance($gdId, $WT_TREE);
						
							$html .= '<option value="' .  $person->getXref() . '" onclick="javascript:location.href=\'' . $person->getHtmlUrl().'\'">' .  $person->getFullName() . ' - ' . $person->getLifeSpan()  . '</option>';
						
					
			}
			
		$html .= '		
			</select>
		';
	return $html;	
	}
	

	/*	==============================================
	*	display $tab as a listing
	*	structure $tab[$i] = array($fam, $children)
	*	===============================================
	*/
	public static  function listingUncles($pid){
		global $WT_TREE;
		$h_uncles = self::getUncles($pid);
		$html = '
			<ul id="lUncles">
			<li class="titrelist">'.I18N::translate('List of uncles & taunts')  .'</li>';			 
			foreach ($h_uncles as $fam =>$uncles){
				
					$html .= '<li class="optionfam" >' . self::displayFam(Family::getInstance($fam, $WT_TREE)) . '</li>';									
					foreach ($uncles as $uncle){			
						if ($uncle){
							$html .= '<li class="optionlist"><a href="' . $uncle->getHtmlUrl().'">' .  $uncle->getFullName() . ' - ' . $uncle->getLifeSpan()  . '</a></li>';
							}					
					}
			}			
		$html .= '		
			</ul>';
	return $html;	
	}
	
		public static  function listingCousins($pid){
		global  $WT_TREE;
		$tab = self::getCousins($pid);
		$html = '
			<ul id="lSiblings">
			<li class="titrelist">'.I18N::translate('List of cousins')  .'</li>';
			 
			foreach ($tab as $fam => $cousins){
				$html .= '<li disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</li>';				
					foreach ($cousins as $cousin ){
						$html .= '<li class="optionlist"><a href="' . $cousin->getHtmlUrl().'">' .  $cousin->getFullName() . ' - ' . $cousin->getLifeSpan()  . '</a></li>';
					}
			}
			
		$html .= '		
			</ul>
		';
	return $html;	
	}
	
		public static  function listingSiblings($xref){
		global $controller, $WT_TREE, $pid;
		$tab = self::getSiblings($xref);
		$html = '
			<ul id="lSiblings">
			<li class="titrelist">'.I18N::translate('List of siblings')  .'</li>';
			 
			foreach ($tab as $fam => $siblings){
				$html .= '<li disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</li>';				
					foreach ($siblings as $sibling ){
						if ($sibling->getXref() != $pid ){
							$html .= '<li class="optionlist"><a href="' . $sibling->getHtmlUrl().'">' .  $sibling->getFullName() . ' - ' . $sibling->getLifeSpan()  . '</a></li>';
						}
					}
			}
			
		$html .= '		
			</ul>
		';
	return $html;	
	}

		public static  function listingNephews($pid){
		global  $WT_TREE;
		$tab = self::getNephews(self::getSiblings($pid) );
		$html = '
			<ul id="lSiblings">
			<li class="titrelist">'.I18N::translate('List of nephews & nieces ')  .'</li>';
			 
			foreach ($tab as $fam => $nephews){
				$html .= '<li  class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</li>';				
					foreach ($nephews as $nephew ){
						if ($nephew->getXref() != $pid ){
							$html .= '<li class="optionlist"><a href="' . $nephew->getHtmlUrl().'">' .  $nephew->getFullName() . ' - ' . $nephew->getLifeSpan()  . '</a></li>';
						}
					}
			}
			
		$html .= '		
			</ul>
		';
	return $html;	
	}

		public static  function listingAllChildren($pid){
		global $WT_TREE;
		$tab = self::getAllChildren($pid);
		$html = '
			<ul id="lSiblings">
			<li class="titrelist">'.I18N::translate('List of all children ')  .'</li>';
			 
			foreach ($tab as $fam => $children){
				$html .= '<li  class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</li>';				
					foreach ($children as $child ){
						if ($child->getXref() != $pid ){
							$html .= '<li class="optionlist"><a href="' . $child->getHtmlUrl().'">' .  $child->getFullName() . ' - ' . $child->getLifeSpan()  . '</a></li>';
						}
					}
			}
			
		$html .= '		
			</ul>
		';
	return $html;	
	}
	
	
		public static  function listingGrandChildren($pid){
		global $WT_TREE;
		$tab = self::getGrandChildren($pid);
		$html = '
			<ul id="lSiblings">
			<li class="titrelist">'.I18N::translate('List of grand-children ')  .'</li>';
			 
			foreach ($tab as $fam => $gchildren){
				$html .= '<li  class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</li>';				
					foreach ($gchildren as $gchild ){
						if ($gchild->getXref() != $pid ){
							$html .= '<li class="optionlist"><a href="' . $gchild->getHtmlUrl().'">' .  $gchild->getFullName() . ' - ' . $gchild->getLifeSpan()  . '</a></li>';
						}
					}
			}
			
		$html .= '		
			</ul>
		';
	return $html;	
	}
	
	
		protected static  function listingGrandParents($tab){
		global $WT_TREE;
		$html = '
			<ul id="lSiblings">
			<li class="titrelist">'.I18N::translate('List of grand-parents')  .'</li>';
			 
			foreach ($tab as $gdId){
				
				//$html .= '<li disabled class="optionfam" value="' . $fam . '">' . self::displayFam(Family::getInstance($fam, $WT_TREE))  . '</li>';				
					$person = Individual::getInstance($gdId, $WT_TREE);
						
							$html .= '<li class="optionlist"><a href="' . $person->getHtmlUrl().'">' .  $person->getFullName() . ' - ' . $person->getLifeSpan()  . '</a></li>';
						
					
			}
			
		$html .= '		
			</ul>
		';
	return $html;	
	}
	
	protected static  function getRightMenu(){
		return '
			<div id="myRightMenu" class="shadow">	
				<ul id="monMenu" class="contextMenu">
					<li  class="GrandParents">
						<a href="#GrandParents">Grand-parents</a>
					</li>
					<li  class="Uncles">
						<a href="#Uncles">Uncles & taunts</a>
					</li>
					<li  class="Cousins">
						<a href="#Cousins">Cousins</a>
					</li>
					<li  class="Siblings">
						<a href="#Siblings">Siblings</a>
					</li>
					<li  class="Nephews">
						<a href="#Nephews">Nephews & nieces</a>
					</li>
					<li  class="GrandChildren">
						<a href="#GrandChildren">Grand-children</a>
					</li>
					<li class="AllChildren">
						<a href="#AllChildren">All children</a>
					</li>
				</ul>
		</div>


		<div id="GrandParents" ><span>GPGPGPGP</span></div>
		<div id="Uncles" ><span>UUUUUUUUU</span></div>
		<div id="Cousins" ><span>CCCCCCCCCCCCCCC</span></div>
		<div id="Siblings" ><span>SSSSSSSSSSSSSSSSSSS</span></span></div>
		<div id="Nephews" ><span>NNNNNNNNNNN</span></div>
		<div id="GrandChildren" ><span>GCGCGCGCGCGC</span></div>
		<div id="AllChildren" ><span>ACACACACACACAC</span></div>	
				
		';
	}
	
	/*	=========================================================== */
	
	/*
	*	return string 
	*/
	private static function displayFam($family){
		global $controller, $WT_TREE;
		$link = 'family.php?&famid=' . $family->getXref() . '&ged=' . $WT_TREE->getName();
		$html = '
		<div><a href="' . $link  . '">';
			if ($family->getHusband()){
			$html .= '<span>' .  $family->getHusband()->getFullName() . '</span> x ';
			}
			if ($family->getWife()){
			$html .= '<span>' .  $family->getWife()->getFullName() . '</span>';
			}
		$html .= '</a></div>
		';
	return $html;	
	}
	
	

	
	private function getparentsId($person){
		$parentsFam = $person->getPrimaryChildFamily();
	}
	


	/*
	*	used with templates PDF
	*
	*/
		
	public function gotMarried($person){
		$spousecount = 0;
			foreach ($person->getSpouseFamilies(Auth::PRIV_HIDE) as $i => $family) {
				$spouse = $family->getSpouse($person);
				if ($spouse && $spouse->canShow() && $this->getMarriage($family)) {
					$spousecount++;
				}
			}
		return $spousecount ;
	}
	
	/**
	 * Determine if the family parents are married.
	 *
	 * Don't use the default function because we want to privatize the record but display the name
	 * and the parents of the spouse if the spouse him/herself is not private.
	 *
	 * @param type $family
	 * @return boolean
	 */
	public function getMarriage($family) {
		global $WT_TREE;
		$record = GedcomRecord::getInstance($family->getXref(), $WT_TREE);
		foreach ($record->getFacts('MARR', false, Auth::PRIV_HIDE) as $fact) {
			if ($fact) {
				return true;
			}
		}
	}
	
	public function getPartners($person){
		
		// get a list of all the spouses
			/*
			 * First, determine the true number of spouses by checking the family gedcom
			 */
			$spousecount = 0;
			foreach ($person->getSpouseFamilies(Auth::PRIV_HIDE) as $i => $family) {
				$spouse = $family->getSpouse($person);
				if ($spouse && $spouse->canShow() && $this->getMarriage($family)) {
					$spousecount++;
				}
			}
			
			$html = '';
			/*
			 * Now iterate thru spouses
			 * $spouseindex is used for ordinal rather than array index
			 * as not all families have a spouse
			 * $spousecount is passed rather than doing each time inside function get_spouse
			 */
			if ($spousecount > 0) {
				$spouseindex = 0;
				foreach ($person->getSpouseFamilies(Auth::PRIV_HIDE) as $i => $family) {
					$spouse = $family->getSpouse($person);
					if ($spouse && $spouse->canShow()) {
						if ($this->getMarriage($family)) {
							$html .= $this->printSpouse($family, $person, $spouse, $spouseindex, $spousecount);
							$spouseindex++;
						} else {
							$html .= $this->printPartner($family, $person, $spouse);
						}
					}
				}
			}
		
	}

	

}







?>