<?php
namespace Andre\WebtreesAddOn\Arbre;
/*
//http://codes-sources.commentcamarche.net/source/47602-ecrire-un-texte-en-cercle-sur-une-image
//http://mtodorovic.developpez.com/php/gd/?page=page_3
*	
*	class myFanChart V-1-0
* 	extends ArbreModule 
*	André DUMAS DEC 2016
*	for WT 1.7.8
*/
use Fisharebest\Webtrees\Filter;
use Fisharebest\Webtrees\I18N;
use Fisharebest\Webtrees\Theme;
use Fisharebest\Webtrees\Individual;


use Andre\WebtreesAddOn\Arbre\ArbreClass;

class myFanChartClass extends ArbreModule{
	
	static  $fcdata; // from cache data & ArbreClass
	static 	$fcstart;
	static  $fcend;
	
	public function __construct() {
		global $WT_TREE;
		self::$fcstart = 180;
		self::$fcend = 360;
	}

private function sq($x){ return $x * $x; }
private function convrad (){ return pi() / 180; }
private function convdeg (){ return 180 / pi(); }

/*
*	fan chart type : conf
*
*/

public static function confFanChartType($fctype){
		switch ($fctype) {
			case '1': //1/2 cercle
				self::$fcstart = 180;
				self::$fcend = 360;
				$fcarcline = 0;
			
			break;
			case '2': //  3/4  cercle
				self::$fcstart = 135;
				self::$fcend = 405;
				$fcarcline = 0;
			
			break;
			case '3': // full cercle
				self::$fcstart = 90;
				self::$fcend = 450;
				$fcarcline = 0;
			
			break;
		}
}

	
	/*	format texte sur plusieurs lignes
	*	centre les lignes du  texte 
	*
	*/
	
	private function textCenter($text){
		$tmp = explode("\n", $text);
		$lenmax = 0;
		$t = '';
		$imax = 0;
			for ($i = 0; $i < count($tmp); $i++){
				if (strlen($tmp[$i]) > $lenmax ){
					$lenmax = strlen($tmp[$i]); 
					$imax = $i;
				} 
			}
			for ($i = 0; $i < count($tmp); $i++){
					if (strlen($tmp[$i]) < $lenmax ){
							$dif = $lenmax - strlen($tmp[$i]);
							$blk = (int)($dif/2);
								for ($j = 0; $j < $blk; $j++){
									$t .= ' ' ;
								}	
					} 
				$t .= $tmp[$i] . "\n";
				
					
			} 
		return $t;
	}
	
	/*
	*	ecriture radiale
	*	adaptation de size en fonction de font
	*	appel 1 fois par gen
	*/
private function adaptFontSize($font, $cellCenter, $gen, $cell, $text){
	$size = 50; 
	$deltar = abs(($cellCenter[$gen][$cell]['cRay'] - $cellCenter[$gen - 1][0]['cRay'])/2);
	$bbox = imagettfbbox($size, 0, $font, $text);
	$hmax = $cellCenter[$gen][$cell]['width']*$cellCenter[$gen][$cell]['cRay']*$this->convrad(); //long corde
	
	$width = abs($bbox[2] - $bbox[0]);// distance from left to right
	$height = abs($bbox[7] - $bbox[1]);// distance from top to bottom

	//commence par hauteur
		while ($height > $hmax){
			$size *= 0.95;
			$bbox = imagettfbbox($size, 0, $font, $text);
			$height = abs($bbox[7] - $bbox[1]);
		}
		//ajuste largeur
		while ($width > $deltar){
			$size *= 0.95;
			$bbox = imagettfbbox($size, 0, $font, $text);
			$width = abs($bbox[2] - $bbox[0]);
		}
	/*	
Then to center your text at ($x,$y) position the code should be like that:

$x -= $width/2;
$y += $heigth/2;

imageTTFText($img,$size,0,$x,$y,$color,$font,$text);

this because (0,0) page origin is topleft page corner and (0,0) text origin is lower-left readable text corner.

	return $size;
*/
	return $size;
	}
	
	
/*
*	param   $angle dans lequel s'inscrit le texte
*	param 	pour un rayon $r
*	longueur texte == longueur arc
*	font-size référence = 20 pour $r = 100 angle = 200 deg
*/
private function getFontSize($text, $angle, $r){
		$fsref = 50;
		$longArc = 2*pi()*$r*$angle/360;
		$nbrLettres = strlen($text); 
			if (!$nbrLettres){exit(); }
	if ( $nbrLettres > 6  ){	
	return $longArc/($nbrLettres*1.2);
	} else {
		return $longArc/(6*1.2);
	}
}

private function arcCircleWrite($im, $color, $font, $size, $r, $phrase, $cx, $cy, $phy = 180, $angle = 180){

  $nbrLettres = strlen($phrase);
  $len = $nbrLettres * $size; 
  
  $step = $angle/($nbrLettres);
  for ($i = 0;$i < $nbrLettres;$i++){
    $angle = $phy + $i * $step;
    $angleRAD = $angle * $this->convrad();
    $x = $cx + cos($angleRAD)*$r;
    $y = $cy + sin($angleRAD)*$r;
    imagettftext($im, $size, 270 - $angle , $x, $y, $color, $font, $phrase[$i]);
	}
	
	/* $r1 = $r - 2*$size;
	writelinels($image, $size, $font, $blue, $cellCenter,  $gen, $cell, $origine, $r1, $lifespan);
	*/
	
  return true;
}


private function arcNameWrite($image, $font, $color , $cellCenter, $gen, $cell, $origine, $text, $text1, $fctype){
    static $size;
	$angle = $cellCenter[$gen][$cell]['width']*0.9;
	if ($gen == 0){
		$phi = 180;
		$angle = 180;
		$r = $cellCenter[$gen][$cell]['cRay']/1.6;
	} else {
		$r = $cellCenter[$gen][$cell]['cRay']/1.9;
		$phi = $cellCenter[$gen][$cell]['cArg'] - $angle/2.1;
	}
	if (($text == '?')){
		$phi = $cellCenter[$gen][$cell]['cArg'];
	} else {	
		$size = (int)$this->getFontSize($text, $angle, $r);
	}
		$this->arcCircleWrite($image, $color, $font, $size, $r, $text, $origine['x'],$origine['y'], $phi, $angle);
		//arcCircleWrite($image, $blue, $font, $size,  $text, $cellCenter, $origine, $lifespan);
	switch ($gen) {
		case 	'0':
					$r1 = $r - 1.5*$size;
					$r = $cellCenter[$gen][$cell]['cRay']/1.9;
		break;			
		case 	'1' :
		case	'2' :
					if  ($fctype == 3){
						$r1 = $r - 0.8*$size;
						$r = $cellCenter[$gen][$cell]['cRay']/1.9;
						$size *= 0.6;
					} else {
					$r1 = $r - 1.5*$size;
					$r = $cellCenter[$gen][$cell]['cRay']/1.9;
					}
		break;
		case 	'4':
		case	'5':
					$r1 = $r - 2*$size;
					$r = $cellCenter[$gen][$cell]['cRay']/2.1;
		break;
		default:
					$r1 = $r - 2*$size;
					$size *= 0.9;
		break;
	}
	//$r1 = $r - 2*$size;
	//$size *= 0.9;
		$this->writelinels($image, $size, $font, $color, $cellCenter,  $gen, $cell, $origine, $r1, $text1);
}

/*  (1815-1902) */
/*
*	write one line
*	in the middle of the cell with right angle
*/
private function writelinels($image, $size, $font,$color, $cellCenter, $gen, $cell, $origine,  $r, $text){
	$smax = 18; //font size max
	$angle_ls = (90 - ($cellCenter[$gen][$cell]['cArg'] -180));
	//$r = $startlsRAD =   $cellCenter[$gen][$cell]['cRay'];
	$sizels = $size*0.8;
	if ($sizels > $smax){$sizels = $smax;}
	$len = strlen($text);
	if ($len%2 == 1){
		$hpos = ($len - 1)/2;
	} else {
		$hpos = $len/2;
	}
	$startlsRAD =   $cellCenter[$gen][$cell]['cArg']*$this->convrad() - ($hpos*$sizels/$r);
	$x_ls = (int)($origine['x'] + $r*cos($startlsRAD));
	$y_ls = (int)($origine['y'] + $r*sin( $startlsRAD));
	imagettftext($image,
				$sizels,
				$angle_ls, $x_ls, $y_ls,
				$color, $font,
				$text
				);
	return true;
}

/*
*	write  lines radial
*	in the middle of the cell with right angle
*/
private function writelineradial($image, $size, $font,$color, $cellCenter, $gen, $cell, $origine, $text){
	$r = $cellCenter[$gen][$cell]['cRay']/2 ;	
	$deltar = abs(($cellCenter[$gen][$cell]['cRay'] - $cellCenter[$gen - 1][0]['cRay'])/2);
	
	if ($cellCenter[$gen][$cell]['cArg'] < 270){
	$angle_ls = (90 - ($cellCenter[$gen][$cell]['cArg'] -180)) - 90 ;
	$r += $deltar/3;
	$startlsRAD = ($cellCenter[$gen][$cell]['cArg'])*$this->convrad();
	} else {
		$angle_ls = (90 - ($cellCenter[$gen][$cell]['cArg'] -180)) + 90 ;
		$r -= $deltar/4;
		$startlsRAD = 0.9955*($cellCenter[$gen][$cell]['cArg'])*$this->convrad();
	}

	if ($gen < 6)  {$sizels = $size*0.7;} else {$sizels = $size*0.5;}
	
	$x_ls = (int)($origine['x'] + $r*cos($startlsRAD));
	$y_ls = (int)($origine['y'] + $r*sin( $startlsRAD));

	imagettftext($image,
				$sizels,
				$angle_ls, $x_ls, $y_ls,
				$color, $font,
				$text
				);
	return true;
}


private function writeTextRadial($image, $angle, $rayon, $text ){
	// Taille police
	
}


/*
*	Calcul pour OutputTemplate1
* 	1 fois par gen 
*	text sur 1 ($gen < 5) ou 2 lignes ($ge > 4) ; lisibilité
*   hauteur text < 0.5*$angle(rad)*$rayon
*	nom d'un côté
*	Lifespan de l'autre côté
* 	size Lifespan = 0.7*$size
*	$xc, $yc cood du centre du rayon -> x1+x2/2 y1 + y2 /2
*/
private function writeTextRadialTemplate1($image, $font, $colort, $angle, $window, $gen, $rayon, $xc, $yc,  $surn, $fname, $lifespan){
	$size = 200; // reference
	$smax = 20; //Taille max police
	$deltar = $rayon;
	
	//$color -> sex	
	switch (trim($colort)) {
		case 'M':
			$color = imagecolorallocate($image,0, 0, 255);
		break;
		case 'F':
			$color = imagecolorallocate($image, 255,   0,   0);
		break;
		default: 
			$color = imagecolorallocate($image,0, 0, 0);
		break;
		
	}
	
	// le pls long
	$surn = strtoupper($surn);
	$text = $fname;
	
	if ( ($nsrn = strlen($surn) ) > ($nfnm = strlen($fname) ) ){$text = $surn;$lmax = $nsrn;} else {$lmax = $nfnm;}
	$lmax = 15;
	$size = $deltar*0.8 / $lmax;
	$bbox = imagettfbbox($size, 0, $font, $text);
			$height = abs($bbox[7] - $bbox[1]);
			$width = abs($bbox[2] - $bbox[0]);
		//Centrage
		$ndelta = $nsrn - $nfnm; 
	if ($gen > 1){	
		//if ($size > $smax){$size = $smax;}
		
		// position du texte
		$offsetchars = abs($ndelta/4)*$size;
		$ecartlf = 8; // ecart/ rayon
		$ecart = $height*1.5;
		if ($angle <= 270){
			$angle_ls = (90 - ($angle -180)) - 90 ;
			$bbox = imagettfbbox($size, 0, $font, $surn);
			$height = abs($bbox[7] - $bbox[1]);
			$width = abs($bbox[2] - $bbox[0]);
			$height = $size;
			$width = strlen($surn)*$size/2;
			$xsn = $xc + ($width)*cos(($angle)*$this->convrad() )/2  - 1.5*$height*cos(($angle - 90)*$this->convrad() );//+ ($width/2 - $ecart)*cos((90-$angle)*$this->convrad() )  ;
			$ysn = $yc + ($width)*sin(($angle)*$this->convrad() )/2 - 1.5*$height*sin(($angle - 90)*$this->convrad() );//- ($height/2 - $ecart)*sin((90-$angle)*$this->convrad() ); 			
			//$xsn = $xc - (0.1*$deltar + $offsetchars)*cos(($angle)*$this->convrad() )/2  - 1*$ecart*cos(($angle - 90)*$this->convrad() );//+ ($width/2 - $ecart)*cos((90-$angle)*$this->convrad() )  ;
			//$ysn = $yc - (0.1*$deltar + $offsetchars)*sin(($angle)*$this->convrad() )/2 - 1*$ecart*sin(($angle - 90)*$this->convrad() );//- ($height/2 - $ecart)*sin((90-$angle)*$this->convrad() ); 
			$bbox = imagettfbbox($size, 0, $font, $fname);
			$height = abs($bbox[7] - $bbox[1]);
			$width = abs($bbox[2] - $bbox[0]);
			$width = strlen($fname)*$size*0.8/2;
			$height = $size*0.8;
			$xfn = $xc + $width*cos(($angle)*$this->convrad() )/2  - 0.4*($height)*cos(($angle - 90)*$this->convrad() );//+ ($width/2 - $ecart)*cos((90-$angle)*$this->convrad() )  ;
			$yfn = $yc + $width*sin(($angle)*$this->convrad() )/2 - 0.4*($height)*sin(($angle - 90)*$this->convrad() );
			
			$width = strlen($lifespan)*$size*0.5/2;
			$height = $size;
			$xl = $xc + $width*cos(($angle)*$this->convrad() )/2  + $height*cos(($angle - 90)*$this->convrad() );//+ ($width/2 - $ecart)*cos((90-$angle)*$this->convrad() )  ;
			$yl = $yc  + $width*sin(($angle)*$this->convrad() )/2  + $height*sin(($angle - 90)*$this->convrad() );
		} else {
			if ($angle < 310){$alpha = 1;} else {$alpha = 1;}
			if ($gen > 3){$size *= 1;$alpha = 1;}
			$angle_ls = (90 - ($angle -180)) + 90 ;
			$width = abs($bbox[2] - $bbox[0]);
			$height = $size;
			$width = strlen($surn)*$size/2;
			$xsn = $xc - 1.5*$width*cos(($angle)*$this->convrad() )/2 + $alpha*1.5*$height*cos(($angle - 90)*$this->convrad() );// + 0*$width ;///2 - $ecart)*cos((90-$angle)*$this->convrad() )  ;
			$ysn = $yc  - 1.5*$width*sin(($angle)*$this->convrad() )/2 + $alpha*1.5*$height*sin(($angle - 90)*$this->convrad() );//- ($height/2 - $ecart)*sin((90-$angle)*$this->convrad() ); 
			
			
			$height = $size;
			$width = strlen($fname)*$size*0.8/2;
			$xfn = $xc - 1.5*$width*cos(($angle)*$this->convrad() )/2 + $alpha*0.4*($height)*cos(($angle - 90)*$this->convrad() );// + 0*$width ;///2 - $ecart)*cos((90-$angle)*$this->convrad() )  ;
			$yfn = $yc  - 1.5*$width*sin(($angle)*$this->convrad() )/2 + $alpha*0.4*($height)*sin(($angle - 90)*$this->convrad() );
			
			
			$height = $size;
			$width = strlen($lifespan)*$size*0.5/2;
			$xl = $xc - $width*cos(($angle)*$this->convrad() )/2 - $alpha*1.3*$height*cos(($angle - 90)*$this->convrad() );// + 0*$width ;///2 - $ecart)*cos((90-$angle)*$this->convrad() )  ;
			$yl = $yc  - $width*sin(($angle)*$this->convrad() )/2 - $alpha*1.3*$height*sin(($angle - 90)*$this->convrad() );
					
		}
if ($gen == 4){
	
$size *= 1;
}
		//
		$color1 = imagecolorallocate($image,0, 0, 0);
		//imagettftext($image, 20, $angle_ls, $xc, $yc, $color1, $font, 'X');
		if ($gen == 4){
			imageline($image,
						0 , $yc,
						5000 , $yc,
						$color1
						);	
		}
		imageTTFText($image, $size, $angle_ls, $xsn, $ysn, $color, $font, $surn);
		imageTTFText($image, $size*0.8, $angle_ls, $xfn, $yfn, $color, $font, $fname);
		imageTTFText($image, $size*0.5, $angle_ls,  $xl, $yl,  $color, $font, $lifespan);
	} else {
		// write root
		$angle_ls = 0;
		$xsn = $xc - $nsrn*$size/2;
		$ysn = $yc - 3*$size;
		
		$xfn = $xc -$nfnm*$size*0.8/2;
		$yfn = $yc - 2*$size;
		
		$xl = $xc - strlen($lifespan)*$size*0.5/2;
		$yl = $yc - $size;
		
		imageTTFText($image,$size,$angle_ls,$xsn,$ysn, $color, $font, $surn);
		imageTTFText($image,$size*0.8,$angle_ls,$xfn,$yfn, $color, $font, $fname);
		imageTTFText($image,$size*0.5,$angle_ls,$xl,$yl, $color, $font, $lifespan);
	}
	return $size;
	}
	

////////////////////////////////////////////


	/*
	*	$lines -> array 3 lines
	*/
private	function write3Lines($image, $font, $color, $cellCenter, $gen, $cell, $origine, $lines){
	$angle = $cellCenter[$gen][$cell]['width']*0.9;
	$r = $cellCenter[$gen][$cell]['cRay']/2;

		for ($ii = 0; $ii < 3; $ii++){
			$size = (int)($this->getFontSize($lines[$ii], $angle, $r));
			$vpos = -0.5;
			if ($ii == 0){$vpos = 0.7;} elseif ($ii == 2){$vpos = -3.2;} 
			$r1 = $r + $size*$vpos;
			if ($ii == 1){$size *=  0.8;} elseif ($ii == 2){$size = 10;}
			$this->writelinels($image, $size, $font, $color, $cellCenter,  $gen, $cell, $origine, $r1, $lines[$ii]);

		}
	return true;	
	}
	
	/*
	*	write root
	*/
private	function write3LinesTemplate1($image, $font, $color, $rayon, $gen, $cell, $origine, $lines){
	$angle = 0; // horizontal
	$r = $rayon/2;
	
		for ($ii = 0; $ii < 3; $ii++){
			$size = (int)($this->getFontSize($lines[$ii], $angle, $r));
			$vpos = -0.5;
			if ($ii == 0){$vpos = 0.7;} elseif ($ii == 2){$vpos = -3.2;} 
			$r1 = $r + $size*$vpos;
			if ($ii == 1){$size *=  0.8;} elseif ($ii == 2){$size = 10;}
			$this->writelinels($image, $size, $font, $color, $cellCenter,  $gen, $cell, $origine, $r1, $lines[$ii]);

		}
	return true;	
	}	
	
	
	/*
	*	my LifSpan 
	*/
	private function getMyLifeSpan($person){
		$db = $person->getBirthDate()->minimumDate()->format('%Y');
		if (!$db){$db = '? ';}
		$dd = $person->getDeathDate()->minimumDate()->format('%Y');
		if (!$dd){$dd = ' ?';}
		
	return '(' . $db . ' - ' .$dd . ')';	
	}

/* Fan Filled sectors 
*  pdf output -> PdfImgTemplate
*/	
protected function getOutput($tab, $fctype){
	global $WT_TREE;
		
	self::confFanChartType($fctype);
$largeur = 2000; //largeur de mon image en PIXELS uniquement !
$hauteur = 2000; //hauteur de mon image en PIXELS uniquement !

//$image = imagecreatetruecolor($largeur,$hauteur);
$image = imagecreate($largeur,$hauteur);
$white = imagecolorallocate($image, 255, 255, 255);

$gray     = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);

// codes couleurs https://www.toutes-les-couleurs.com/code-couleur-rvb.php
$color = "BEDFFE";
$rouge = hexdec(substr($color,0,2)); //conversion du canal rouge
$vert = hexdec(substr($color,2,4)); //conversion du canal vert
$bleu = hexdec(substr($color,4,6)); //conversion du canal bleu
// Allocation de couleurs

$red   = imagecolorallocate($image, 255,   0,   0);
$green = imagecolorallocate($image,   0, 255,   0);
$blue  = imagecolorallocate($image,   0,   0, 255);
$darkgray = imagecolorallocate($image, 0x90, 0x90, 0x90);
$navy     = imagecolorallocate($image, 0x00, 0x00, 0x80);
$darknavy = imagecolorallocate($image, 0x00, 0x00, 0x50);
$red      = imagecolorallocate($image, 0xFF, 0x00, 0x00);
$darkred  = imagecolorallocate($image, 0x90, 0x00, 0x00);
$lightblue = imagecolorallocate($image,173, 216, 230);
$lightpink = imagecolorallocate($image,254, 182, 193);



/* on créé la couleur et on l'attribue à une variable pour ne pas la perdre */
$couleur = imagecolorallocate($image,$rouge,$vert,$bleu);
//imagerectangle($image,1,1,$largeur,$hauteur,$navy);

/* on créé l'image en vraies couleurs avec une largeur de 50 pixels et une hauteur de 100 pixels */
$origine= array('x'=>$largeur / 2, 'y'=>$hauteur / 2);
$rayon = $hauteur - 20;
/*
* 	cellCenter[gen][case] = array( 	angCenter, 
*								rayonCenter
*								) )
*
*/
$cellCenter = array();


/*
*   Write on an arc
*/
//$font = 'fonts/truetype/freefont/FreeMonoBold.ttf';
$font = Theme::theme()->parameter('chart-font-name');

$gen = count($tab);
$nombreSecteurs = pow(2, $gen - 1);

$start = self::$fcstart;
$end = self::$fcend;

$incAngle = ($end - $start)/$nombreSecteurs;
$deltarayon = (int)($rayon / ($gen) );

	for ($j = $gen - 1 ; $j >= 0; $j--){
		if (!($j == $gen -1) ){
			$rayon -= $deltarayon; 
		}
		$start1 = $start;
		$nombreSecteurs = pow(2, $j);
		$incAngle = ($end - $start)/$nombreSecteurs;
		
		for ($i = 0; $i <$nombreSecteurs; $i++){
			if (($i != 0)){
			$start1 += $incAngle;
			}
			$end1 = $start1 + $incAngle;
		
				if (($i%2) == 1){
					$col = $lightpink;  
				} else {
					$col = $lightblue;
				}
				$cellCenter[$j][] = array('cArg'=>
										(($start1 + $end1) / 2),
										'width' => $incAngle,
										'cRay' =>($rayon - ($deltarayon/2))
										) ;
			imagefilledarc($image,
				$origine['x'],
				$origine['y'],
				$rayon,
				$rayon,
				$start1,
				$end1,
				$col,
				IMG_ARC_PIE
			);

		$size = 50; //default value;
		}		
	}			

/////////////////////////////////
$color = $blue;
	for ($j = 1; $j <= count($tab) ; $j++){
		if ($tab[$j] ){	
			for ($i = 0; $i < count($tab[$j]); $i++){
				$g = $j - 1; $cell = $i;
				if ($person = Individual::getInstance($tab[$j][$i]['id'], $WT_TREE)){				
					$names = $this->getShortName($person);
					$text1 = $this->getMyLifeSpan($person) ;
					if ($j <= 4){
						$text = utf8_decode($names['givn'] . ' ' . $names['surn']) ;
						$this->arcNameWrite($image, $font, $color , $cellCenter, $g, $cell, $origine, $text, $text1, $fctype);
					} else {
						$text = array(utf8_decode($names['surn']), utf8_decode($names['givn']), $text1);
						$this->write3Lines($image, $font, $color, $cellCenter, $g, $cell, $origine, $text);
					}
				} else {
					$text = '?';
					$text1 =  '(? - ?)';
					$this->arcNameWrite($image, $font, $color , $cellCenter, $g, $cell, $origine, $text, $text1, $fctype);				
				}								
			}
		} 
	}


////////////////////////////////

		$dir = $this->getSetting('ARBRE_CACHE_DIR');
		$cache = WT_DATA_DIR .  'arbre_cache' . DIRECTORY_SEPARATOR . 'fan_arbre.png';

			imagepng($image, $cache); //renvoie une image sous format png
			imagedestroy($image); //détruit l'image, libérant ainsi de la mémoire
		return true;
		}

	////////////////////////////////////////
	/*	Eventails trats -> pdf  PdfewTreeTemplate1*/
		protected function getOutputTemplate2($tab, $fctype){
	global $WT_TREE;
		
	self::confFanChartType($fctype);
$largeur = 2000; //largeur de mon image en PIXELS uniquement !
$hauteur = 1000; //hauteur de mon image en PIXELS uniquement !

//$image = imagecreatetruecolor($largeur,$hauteur);
$image = imagecreate($largeur,$hauteur);
$white = imagecolorallocate($image, 255, 255, 255);

$gray     = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);

// codes couleurs https://www.toutes-les-couleurs.com/code-couleur-rvb.php
$color = "BEDFFE";
$rouge = hexdec(substr($color,0,2)); //conversion du canal rouge
$vert = hexdec(substr($color,2,4)); //conversion du canal vert
$bleu = hexdec(substr($color,4,6)); //conversion du canal bleu
// Allocation de couleurs

$red   = imagecolorallocate($image, 255,   0,   0);
$green = imagecolorallocate($image,   0, 255,   0);
$blue  = imagecolorallocate($image,   0,   0, 255);
$darkgray = imagecolorallocate($image, 0x90, 0x90, 0x90);
$navy     = imagecolorallocate($image, 0x00, 0x00, 0x80);
$darknavy = imagecolorallocate($image, 0x00, 0x00, 0x50);
$red      = imagecolorallocate($image, 0xFF, 0x00, 0x00);
$darkred  = imagecolorallocate($image, 0x90, 0x00, 0x00);
$lightblue = imagecolorallocate($image,173, 216, 230);
$lightpink = imagecolorallocate($image,254, 182, 193);
$noir = imagecolorallocate($image, 0, 0, 0);


/* on créé la couleur et on l'attribue à une variable pour ne pas la perdre */
$couleur = imagecolorallocate($image,$rouge,$vert,$bleu);
//imagerectangle($image,1,1,$largeur,$hauteur,$navy);

/* on créé l'image en vraies couleurs avec une largeur de 50 pixels et une hauteur de 100 pixels */
$origine= array('x'=>$largeur / 2, 'y'=>$hauteur / 2);
$rayon = $hauteur - 20;
/*
* 	cellCenter[gen][case] = array( 	angCenter, 
*								rayonCenter
*								) )
*
*/
$cellCenter = array();

$font = Theme::theme()->parameter('chart-font-name');

$gen = count($tab);
$nombreSecteurs = pow(2, $gen - 1);

$start = self::$fcstart;
$end = self::$fcend;

$incAngle = ($end - $start)/$nombreSecteurs;
$deltarayon = (int)($rayon / ($gen) );
/*
	for ($j = $gen - 1 ; $j >= 0; $j--){
		if (!($j == $gen -1) ){
			$rayon -= $deltarayon; 
		}
		$start1 = $start;
		$nombreSecteurs = pow(2, $j);
		$incAngle = ($end - $start)/$nombreSecteurs;
		
		for ($i = 0; $i <$nombreSecteurs; $i++){
			if (($i != 0)){
			$start1 += $incAngle;
			}
			$end1 = $start1 + $incAngle;
		
				if (($i%2) == 1){
					$col = $lightpink;  
				} else {
					$col = $lightblue;
				}
				$cellCenter[$j][] = array('cArg'=>
										(($start1 + $end1) / 2),
										'width' => $incAngle,
										'cRay' =>($rayon - ($deltarayon/2))
										) ;
			imagefilledarc($image,
				$origine['x'],
				$origine['y'],
				$rayon,
				$rayon,
				$start1,
				$end1,
				$col,
				IMG_ARC_PIE
			);

	$size = 50; //default value;
		}		
}			

*/
///////////////////////
	$cx = $origine['x'];
	$cy = $origine['y'];
	$gen = count($tab) - 1;
	
	$thickness = 3;
	imagesetthickness ( $image , $thickness );
	/* racine 1/2 cercle
			$rayon  = $deltarayon;
			imagearc($image,
				$origine['x'],
				$origine['y'],
				$rayon,
				$rayon,
				$start,
				$end,
				$blue
			);
			
				$x = $cx + $rayon*cos( $start*$this->convrad() )/2;
				$y = $cy + $rayon*sin( $start*$this->convrad())/2;
					imageline(	$image,
						$x , $y,
						$cx , $cy,
						$noir
						);
						
				$x = $cx + $rayon*cos( $end*$this->convrad() )/2;
				$y = $cy + $rayon*sin( $end*$this->convrad())/2;
					imageline(	$image,
						$x , $y,
						$cx , $cy,
						$noir
						);		
	
		
		*/
		for ($j = 2; $j <= $gen  ; $j++){			
			$start1 = $start;
			
			$nombreSecteurs = pow(2, $j  - 1); // pb decalage $tab
			$incAngle = ($end - $start)/$nombreSecteurs;
			
			for ($i = 0; $i < $nombreSecteurs; $i++){				
				$angle = ($start + ($i + 1 )*$incAngle - $incAngle / 2)*$this->convrad();
				$x1 = $cx + $rayon*cos( $angle )/2;
				$y1 = $cy + $rayon*sin( $angle)/2;
	
				$rayon1 = $rayon + $deltarayon; 
				$x2 = $cx + $rayon1*cos( $angle )/2;
				$y2 = $cy + $rayon1*sin( $angle)/2;
				
				imageline(	$image,
						$x1, $y1,
						$x2, $y2,
						$noir
						);
					$xc =  ($x1 + $x2)/2;
					$yc =  ($y1 + $y2)/2;
				 /*} else {
					$x = $cx + $rayon*cos( $end*$this->convrad() )/2;
				$y = $cy + $rayon*sin( $end*$this->convrad())/2;
					imageline(	$image,
						$x , $y,
						$cx , $cy,
						$noir
						);	
				}*/	
					//if ($i == 0){
					// couleur -> sex
						if (($i%2) == 1){
							$col = $lightpink;  
						} else {
							$col = $lightblue;
						}
						
						
						////////// labels
						$jj = $j + 1;
						if ($tab[$jj] && ($person = Individual::getInstance($tab[$jj][$i]['id'], $WT_TREE))){				
								$names = $this->getShortName($person);
								$surn = $names['surn'];
								$fname = $names['givn'];
								$lifespan = $this->getMyLifeSpan($person) ;
								$col = $person->getSex();
								
									$fname = utf8_decode($fname);
									$surn  = utf8_decode($surn);
									$angle =  $start + ($i + 1 )*$incAngle - $incAngle / 2;
									$this->writeTextRadialTemplate1($image, $font, $col, $angle, $incAngle, $jj, $deltarayon, $x2, $y2,  $surn, $fname, $lifespan);
							} else {
								$surn = '?';
								$lifespan =  '(? - ?)';
								//$this->arcNameWrite($image, $font, $color , $cellCenter, $g, $cell, $origine, $text, $text1, $fctype);
								$angle =  $start + ($i + 1 )*$incAngle - $incAngle / 2;
									$this->writeTextRadialTemplate1($image, $font, $col, $angle, $incAngle, $jj, $deltarayon, $x2, $y2,  $surn, $fname, $lifespan);
				
							}	
						
						///////////
						
						
					if ($j < $gen){ //pas d'arc sans branche, dernier niveau
						$s = ($start + ($i + 1 )*$incAngle - $incAngle / 2) - ($incAngle / 4);
						$e = ($start + ($i + 1 )*$incAngle - $incAngle / 2) + ($incAngle / 4);
							imagearc($image,
								$origine['x'],
								$origine['y'],
								$rayon1,
								$rayon1,
								$s,
								$e,
								$noir
							);	
					}	
					
			}
		$rayon += $deltarayon;
		}
	

/////////////////////////////////

////////////////////////////////

		$dir = $this->getSetting('ARBRE_CACHE_DIR');
		$cache = WT_DATA_DIR .  'arbre_cache' . DIRECTORY_SEPARATOR . 'fan_arbre.png';
		
		
		
		/* http://stackoverflow.com/questions/19527455/php-how-to-solve-ob-start-in-combination-imagepng-issue
		
I'm not sure how to solve your issue with ob_start(), but I have an alternative for what you are doing that don't envolve output buffers.
imagepng($imgSignature, 'php://memory/file.png');
$base64Signature = base64_encode(file_get_contents('php://memory/file.png'));
		*/
		//$stream = 'php://memory/file.png';
		$stream = 'data/arbre_cache/fan_arbre.png';
			ob_start();
			header('"Content-Type: ' . 'image/png"');
			imagepng($image, $cache); //renvoie une image sous format png
			//imagepng($image, $stream);
			imagedestroy($image); //détruit l'image, libérant ainsi de la mémoire
		//return ob_end_clean();
		return true;
		}


		protected function getOutputTemplate1($tab, $fctype){
	global $WT_TREE;
		
	self::confFanChartType($fctype);
	$gen = count($tab) - 0;// .... 1
	$fntype = 2;  // = 1 ou 2 :  place de l'origine en bas....
	
$largeur = 6000; //largeur de mon image en PIXELS uniquement !
$hauteur = $largeur / 2; //hauteur de mon image en PIXELS uniquement !
//if ($fctype == 1){$hauteur = $largeur*($gen +1) / ($gen * 2);};


//$image = imagecreatetruecolor($largeur,$hauteur);
$image = imagecreate($largeur,$hauteur);
$white = imagecolorallocate($image, 255, 255, 255);
$gray     = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);
// codes couleurs https://www.toutes-les-couleurs.com/code-couleur-rvb.php
$color = "BEDFFE";
$rouge = hexdec(substr($color,0,2)); //conversion du canal rouge
$vert = hexdec(substr($color,2,4)); //conversion du canal vert
$bleu = hexdec(substr($color,4,6)); //conversion du canal bleu
// Allocation de couleurs
$red   = imagecolorallocate($image, 255,   0,   0);
$green = imagecolorallocate($image,   0, 255,   0);
$blue  = imagecolorallocate($image,   0,   0, 255);
$darkgray = imagecolorallocate($image, 0x90, 0x90, 0x90);
$navy     = imagecolorallocate($image, 0x00, 0x00, 0x80);
$darknavy = imagecolorallocate($image, 0x00, 0x00, 0x50);
$red      = imagecolorallocate($image, 0xFF, 0x00, 0x00);
$darkred  = imagecolorallocate($image, 0x90, 0x00, 0x00);
$lightblue = imagecolorallocate($image,173, 216, 230);
$lightpink = imagecolorallocate($image,254, 182, 193);
$noir = imagecolorallocate($image, 0, 0, 0);

/* on créé la couleur et on l'attribue à une variable pour ne pas la perdre */
$couleur = imagecolorallocate($image,$rouge,$vert,$bleu);
//imagerectangle($image,1,1,$largeur,$hauteur,$navy);

/* on créé l'image en vraies couleurs avec une largeur de 50 pixels et une hauteur de 100 pixels */

$origine= array('x'=>$largeur / 2, 'y'=>$hauteur / $fntype);
$rayon = $hauteur - 20; // voir 2 -> rayon/2 dans la suite..... 
//$rayon /= 1;
//$cellCenter = array();
$font = Theme::theme()->parameter('chart-font-name');
//$gen = 3;
$start = self::$fcstart;
$end = self::$fcend;

///////////////////////
	$cx = $origine['x'];
	$cy = $origine['y'];   
	
	$deltarayon = (int)($rayon / ($gen) );
	$thickness = 3;
	imagesetthickness ( $image , $thickness );
	
		$rayon  = $deltarayon;
		for ($j = 1; $j <= $gen  ; $j++){			
			$start1 = $start;			
			$nombreSecteurs = pow(2, $j -1 ); // pb decalage $tab
			$incAngle = ($end - $start)/$nombreSecteurs;
			
			for ($i = 0; $i < $nombreSecteurs; $i++){	
				if ($j > 1){	
					$angle = ($start + ($i + 1 )*$incAngle - $incAngle / 2)*$this->convrad();
					// premier point
					$x1 = $cx + $rayon*cos( $angle )/2;
					$y1 = $cy + $rayon*sin( $angle)/2;
									
					//secod point
					$rayon1 = $rayon + $deltarayon; 
					$x2 = $cx + $rayon1*cos( $angle )/2;
					$y2 = $cy + $rayon1*sin( $angle)/2;
									
							imageline(	$image,
								$x1, $y1,
								$x2, $y2,
								$noir
							);
						$xc =  ($x1 + $x2)/2;
						$yc =  ($y1 + $y2)/2;																
							////////// labels	
							
								if ($tab[$j] && ($person = Individual::getInstance($tab[$j][$i]['id'], $WT_TREE))){				
									$names = $this->getShortName($person);
									$surn = $names['surn'];
									$fname = $names['givn'];
									$lifespan = $this->getMyLifeSpan($person) ;
									$col = $person->getSex();								
										$fname = utf8_decode($fname);
										$surn  = utf8_decode($surn);
										$angle =  $start + ($i + 1 )*$incAngle - $incAngle / 2;
										$this->writeTextRadialTemplate1($image, $font, $col, $angle, $incAngle, $j, $deltarayon, $xc, $yc,  $surn, $fname, $lifespan);
								} else {	
									$surn = '?';
									$fname = '?';
									$lifespan =  '(? - ?)';							
									$angle =  $start + ($i + 1 )*$incAngle - $incAngle / 2;
									$col = '?';
										$this->writeTextRadialTemplate1($image, $font, $col, $angle, $incAngle, $j, $deltarayon, $xc, $yc,  $surn, $fname, $lifespan);				
								}	
					}
				
						///////////
						
					// -------------Tracé des arcs------------
					if (($j < $gen) ){ //pas d'arc sans branche ensuite, dernier niveau
						if ($j != 1){
						$s = ($start + ($i + 1 )*$incAngle - $incAngle / 2) - ($incAngle / 4);
						$e = ($start + ($i + 1 )*$incAngle - $incAngle / 2) + ($incAngle / 4);
							imagearc($image,
								$origine['x'],
								$origine['y'],
								$rayon1,
								$rayon1,
								$s,
								$e,
								$noir
							);	
						} 
						else 
						{ //root cercle
							//  racine 1/2 cercle
							if ($col ='M'){$couleur = $lightblue;} else{$couleur = $lightpink;}
							$rayon  = $deltarayon;
							imagefilledarc($image,
								$origine['x'],
								$origine['y'],
								$rayon,
								$rayon,
								$start,
								$end,
								$couleur,
								IMG_ARC_PIE
							);
							//base du cercle
							$x = $cx + $rayon*cos( $start*$this->convrad() )/1;
							$y = $cy + $rayon*sin( $start*$this->convrad())/1;							
								imageline(	$image,
									$x , $y,
									$cx , $cy,
									$noir
								);						
							$x = $cx + $rayon*cos( $end*$this->convrad() )/1;
							$y = $cy + $rayon*sin( $end*$this->convrad())/1;
								imageline(	$image,
									$x , $y,
									$cx , $cy,
									$noir
									);	
							// names------ $j = 1 root
							if ( ($person = Individual::getInstance($tab[$j][$i]['id'], $WT_TREE))){				
								$names = $this->getShortName($person);
								$surn = $names['surn'];
								$fname = $names['givn'];
								$lifespan = $this->getMyLifeSpan($person) ;
								$col = $person->getSex();
								
									$fname = utf8_decode($fname);
									$surn  = utf8_decode($surn);
									$angle =  180;
									$incAngle = 180;									
									$this->writeTextRadialTemplate1($image, $font, $col, $angle, $incAngle, $j, $deltarayon, $cx, $cy,  $surn, $fname, $lifespan);				
							}
						}
											
					} 						
			}
		if ($j > 1){$rayon += $deltarayon;}
		}
	

/////////////////////////////////
////////////////////////////////

		$dir = $this->getSetting('ARBRE_CACHE_DIR');
		$cache = WT_DATA_DIR .  'arbre_cache' . DIRECTORY_SEPARATOR . 'fan_arbre.png';
		
		
		
		/* http://stackoverflow.com/questions/19527455/php-how-to-solve-ob-start-in-combination-imagepng-issue
		
I'm not sure how to solve your issue with ob_start(), but I have an alternative for what you are doing that don't envolve output buffers.
imagepng($imgSignature, 'php://memory/file.png');
$base64Signature = base64_encode(file_get_contents('php://memory/file.png'));
		*/
		//$stream = 'php://memory/file.png';
		$stream = 'data/arbre_cache/fan_arbre.png';
			ob_start();
			header('"Content-Type: ' . 'image/png"');
			imagepng($image, $cache); //renvoie une image sous format png
			//imagepng($image);
			//imagepng($image, $stream);
			imagedestroy($image); //détruit l'image, libérant ainsi de la mémoire
		//return ob_end_clean();
		//$this->darkroom($cache, '', 500, $height = 0, $useGD = TRUE);
		return true;
		}
		

	/////////////////////////////////////////
		
		/*
	*	SURN and 2 given names only
	*/
	protected function getShortName(Individual $person){
		$count_givn = 2;
		if ($person->canShowName()) {
			$tmp        = $person->getAllNames();
			$givn       = $tmp[$person->getPrimaryName()]['givn'];
			$surn       = $tmp[$person->getPrimaryName()]['surname'];
			$new_givn   = explode(' ', $givn);
		
			if (count($new_givn) > 1){ 
			$givn = $new_givn[0] ;//. ' ' . $new_givn[1];
			} else {
				$givn = $new_givn[0];
			}
			$shortname = array( 'givn' => $givn, 
								'surn' => $surn
			);
			return $shortname;
		} else {
			return I18N::translate('Private');
		}
	}
	
		/**
* La fonction darkroom() renomme et redimensionne les photos envoyées lors de l'ajout d'un objet.
* @param $img String Chemin absolu de l'image d'origine.
* @param $to String Chemin absolu de l'image générée (.jpg).
* @param $width Int Largeur de l'image générée. Si 0, valeur calculée en fonction de $height.
* @param $height Int Hauteur de l'image génétée. Si 0, valeur calculée en fonction de $width.
* Si $height = 0 et $width = 0, dimensions conservées mais conversion en .jpg
*/
function darkroom($img, $to, $width = 0, $height = 0, $useGD = TRUE){
 
	$dimensions = getimagesize($img);
	$ratio      = $dimensions[0] / $dimensions[1];
 
	// Calcul des dimensions si 0 passé en paramètre
	if($width == 0 && $height == 0){
		$width = $dimensions[0];
		$height = $dimensions[1];
	}elseif($height == 0){
		$height = round($width / $ratio);
	}elseif ($width == 0){
		$width = round($height * $ratio);
	}
 
	if($dimensions[0] > ($width / $height) * $dimensions[1]){
		$dimY = $height;
		$dimX = round($height * $dimensions[0] / $dimensions[1]);
		$decalX = ($dimX - $width) / 2;
		$decalY = 0;
	}
	if($dimensions[0] < ($width / $height) * $dimensions[1]){
		$dimX = $width;
		$dimY = round($width * $dimensions[1] / $dimensions[0]);
		$decalY = ($dimY - $height) / 2;
		$decalX = 0;
	}
	if($dimensions[0] == ($width / $height) * $dimensions[1]){
		$dimX = $width;
		$dimY = $height;
		$decalX = 0;
		$decalY = 0;
	}
 
	// Création de l'image avec la librairie GD
	if($useGD){
		$pattern = imagecreatetruecolor($width, $height);
		$type = mime_content_type($img);
		switch (substr($type, 6)) {
			case 'jpeg':
				$image = imagecreatefromjpeg($img);
				break;
			case 'gif':
				$image = imagecreatefromgif($img);
				break;
			case 'png':
				$image = imagecreatefrompng($img);
				break;
		}
		imagecopyresampled($pattern, $image, 0, 0, 0, 0, $dimX, $dimY, $dimensions[0], $dimensions[1]);
		imagedestroy($image);
		//imagejpeg($pattern, $to, 100);
 
		return TRUE;
 
        // Création de l'image avec ImageMagick
	}else{
		$cmd = '/usr/bin/convert -resize '.$dimX.'x'.$dimY.' "'.$img.'" "'.$dest.'"';
       		shell_exec($cmd);
 
       		$cmd = '/usr/bin/convert -gravity Center -quality '.self::$quality.' -crop '.$largeur.'x'.$hauteur.'+0+0 -page '.$largeur.'x'.$hauteur.' "'.$dest.'" "'.$dest.'"';
            		shell_exec($cmd);	
	}
	return TRUE;
}
		
		
}

?>

